-- initialise the default
local frame = CreateFrame("FRAME", "UnsheathMoveFrame");
frame:RegisterEvent("PLAYER_ENTERING_WORLD");
local function eventHandler(self, event, ...)
	if UNSHEATHMOVE_DEFAULT == true then
		ToggleOnOff = 'Enabled'
	else ToggleOnOff = 'Disabled'
	end
end
frame:SetScript("OnEvent", eventHandler);

-- set up key bindings
BINDING_HEADER_UNSHEATHMOVE = "UnsheathMove"
BINDING_NAME_UNSHEATHMOVE = "Toggle"

-- Slash Commands
SLASH_UNSHEATHMOVE1 = '/um';
local function handler(param, editbox)
	if param == 'toggle' then
	ToggleSheath()
	ToggleDefault()
  print('UnsheathMove is', ToggleOnOff);
  elseif param == 'config' then
	InterfaceOptionsFrame_OpenToCategory("UnsheathMove")
	InterfaceOptionsFrame_OpenToCategory("UnsheathMove") -- sometimes the blizz options panel doesnt go to the right page.. this forces it to go to the right page
 else
  print('-----------------------------------------');
  print('UnsheathMove is', ToggleOnOff);
  print('Possible options are:');
  print('/um toggle - to toggle on or off');
  print('/um config - to open the options screen');
  print('-----------------------------------------');
 end
end
SlashCmdList["UNSHEATHMOVE"] = handler;

--set up options screen
local UnsheathMoveDefaultText = "Enable the addon on startup"
local unsheathmove = CreateFrame("Frame", "unsheathmoveoptions", InterfaceOptionsFramePanelContainer)
unsheathmove:Hide()
unsheathmove.name = "UnsheathMove"
local title = unsheathmove:CreateFontString(nil, "ARTWORK", "GameFontNormalLarge")
title:SetPoint("TOPLEFT", 16, -16)
title:SetText("UnsheathMove v1.1") 
InterfaceOptions_AddCategory(unsheathmove)

local btnUnsheathMoveDefault = CreateFrame("CheckButton", "UnsheathMoveDefaultButton", unsheathmove, "OptionsBaseCheckButtonTemplate")
btnUnsheathMoveDefault:SetPoint("TOPLEFT", 16, -35)
btnUnsheathMoveDefault:SetScript("OnClick", function(frame)
	if frame:GetChecked() then
		PlaySound("igMainMenuOptionCheckBoxOn")
		UNSHEATHMOVE_DEFAULT = true
	else
		PlaySound("igMainMenuOptionCheckBoxOff")
		UNSHEATHMOVE_DEFAULT = nil
	end
end)
btnUnsheathMoveDefault:SetScript("OnShow", function(frame)
	frame:SetChecked(UNSHEATHMOVE_DEFAULT)
end)
local btnUnsheathMoveDefaultText = btnUnsheathMoveDefault:CreateFontString(nil, "ARTWORK", "GameFontHighlight")
btnUnsheathMoveDefaultText:SetPoint("LEFT", btnUnsheathMoveDefault, "RIGHT", 0, 1)
btnUnsheathMoveDefaultText:SetText(UnsheathMoveDefaultText)

-- Toggle from keybind
function UnsheathMoveToggle()
	ToggleSheath()
	ToggleDefault()
end

-- Toggles default and checks against actual sheathstate to set variable
function ToggleDefault()
		if ToggleOnOff == 'Disabled' and GetSheathState() == 1
		then ToggleOnOff = 'Enabled'
		elseif ToggleOnOff == 'Enabled' and GetSheathState() == 1
		then ToggleOnOff = 'Disabled'
		else
			ToggleOnOff = 'Disabled'
		end
end

--unsheath if enabled on moving forward
hooksecurefunc("MoveForwardStart", function()
	if GetSheathState() == 1 
	and ToggleOnOff == 'Enabled'
	then ToggleSheath()
	ToggleOnOff = 'Enabled'
	end
end)

--unsheath if enabled and autorun is toggled
hooksecurefunc("ToggleAutoRun", function()
	if GetSheathState() == 1 
	and ToggleOnOff == 'Enabled'
	then ToggleSheath()
	ToggleOnOff = 'Enabled'
	end
end)